/*
***************************************************************************
*
* Author: Teunis van Beelen
*
* Copyright (C) 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Teunis van Beelen
*
* teuniz@gmail.com
*
* hacked by themroc 2013-10-28
*
***************************************************************************
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation version 2 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
***************************************************************************
*
* This version of GPL is at http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
*
***************************************************************************
*/

/* last revision: February 1, 2013 */

/* For more info and how to use this libray, visit: http://www.teuniz.net/RS-232/ */

/* This hacked version always returns -1 in case of error */


#ifndef rs232_INCLUDED
#define rs232_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include <stdio.h>
#include <string.h>

#ifdef __linux__

#include <termios.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <limits.h>

#define RS232_HANDLE int

#else

#include <windows.h>

#define RS232_HANDLE HANDLE

#endif

int RS232_OpenComport(char * com_name, int baudrate, RS232_HANDLE * com_handle);
int RS232_PollComport(RS232_HANDLE, void *, int);
int RS232_SendByte(RS232_HANDLE, char);
int RS232_SendBuf(RS232_HANDLE, void *, int);
void RS232_CloseComport(RS232_HANDLE);
void RS232_cputs(RS232_HANDLE, const char *);
int RS232_IsCTSEnabled(RS232_HANDLE);
int RS232_IsDSREnabled(RS232_HANDLE);
void RS232_enableDTR(RS232_HANDLE);
void RS232_disableDTR(RS232_HANDLE);
void RS232_enableRTS(RS232_HANDLE);
void RS232_disableRTS(RS232_HANDLE);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
