/*****************************************************\

  The V.U.C. Protocol

\*****************************************************/

// Protocol version
#define VUC_PROTO_MAJOR		0
#define VUC_PROTO_MINOR		1
#define VUC_PROTO_VER		G_STRINGIFY(VUC_PROTO_MAJOR) "." G_STRINGIFY(VUC_PROTO_MINOR)

// Byte-order is fixed to little-endian (for now)
#define VUC_I16_TO_VE		GINT16_TO_LE
#define VUC_U16_TO_VE		GUINT16_TO_LE
#define VUC_I32_TO_VE		GINT32_TO_LE
#define VUC_U32_TO_VE		GUINT32_TO_LE
#define VUC_VE_TO_I16		GINT16_FROM_LE
#define VUC_VE_TO_U16		GUINT16_FROM_LE
#define VUC_VE_TO_I32		GINT32_FROM_LE
#define VUC_VE_TO_U32		GUINT32_FROM_LE

// Commands from control-panel
#define VUC_CMD_META		0x40	// "Meta"-command
#define VUC_CMD_PUT		0x80	// Send value(s) to uC
#define VUC_CMD_GET		0xc0	// Get Value(s) from uC
#define VUC_CMD__MAX		0xcf

// Replies from uC
#define VUC_REP_META		0x40	// dito
#define VUC_REP_PUT		0x80	// Send Value(s) to PC
#define VUC_REP__MAX		0x8f

// Protocoll-overhead
#define VUC_META_ACK		0x01	// uC<>PC Ok
#define VUC_META_NAK		0x02	// uC<>PC Nope
#define VUC_META_XON		0x03	// uC<>PC Start
#define VUC_META_XOFF		0x04	// uC<>PC Stop
#define VUC_META_INIT		0x05	// uC<>PC Reset
#define VUC_META_EXT		0x06	// uC<>PC Extended command (to be defined) - 1 byte length and UTF-8-data follows

#define VUC_META_MSG		0x30	// uC->PC Tell the user - 1 byte length and UTF-8-data follows
#define VUC_META_DBG		0x31	// uC->PC Debug msg - dito
#define VUC_META_ID		0x35	// uC->PC identify board - 1 byte length and arbitrary data follows
#define VUC_META_HELLO		0x36	// uC->PC set protocol-version - 1 byte follows ("1.4" = 0x14)


// to switch off all debugging
#define VUC_DBG_ON	1

// low-level io
#define VUC_DBG_IO	0

// protocol
#define VUC_DBG_PROTO	0
