
#ifndef VUC_DBG_ON
#  define VUC_DBG_ON	0
#endif

// protocol
#ifndef VUC_DBG_PROTO
#  define VUC_DBG_PROTO	VUC_DBG_ON
#endif

void __inline__ vuc_input (u8 c)
{
  static u8 state= 0;
  static u8 adr, cmd;

  static u8 data[VUC_IN_DATA_SIZE+1];
  static u8 data_len, data_cnt, data_p= 0;

  switch (state) {
    case 0:
      cmd= c&0xc0; adr= c&0x3f;
      if (cmd==0) {
        vuc_err("Bad cmd", c); break;
      }
      if (cmd==VUC_CMD_META) {
        switch (adr) {
          case VUC_META_HELLO:
            data_len= data_cnt= 1; state= 2; break;
          case VUC_META_ID: case VUC_META_EXT: case VUC_META_MSG: case VUC_META_DBG:
            state= 1; break;
#ifdef VUC_FLOW_CTR
          case VUC_META_XON:
            vuc_out_on= 1; break;
          case VUC_META_XOFF:
            vuc_out_on= 0; break;
#endif
          default:
            vuc_meta(adr, 0, NULL);
        }
        break;
      }
      // TODO: adr above 64
      if ( (cmd==VUC_CMD_PUT && adr>=VUC_PUT_ADRS)
        || (cmd==VUC_CMD_GET && adr>=VUC_GET_ADRS) ) {
        vuc_err("Bad adr", adr); break;
      }
      if (cmd==VUC_CMD_PUT) {
        data_len= data_cnt= vuc_put_meta[adr].no_of_bytes; state= 2; break;
      }
//      if (cmd==VUC_CMD_GET) { // can only be VUC_CMD_GET
#if (VUC_DBG_PROTO)
        vuc_dbg_beg(4+2); vuc_dbgs("GET "); vuc_dbgn8(adr); vuc_dbg_end();
#endif
        vuc_get_meta[adr].func(data);
//        break;
//      }
      break;
    case 1:
      data_len= data_cnt= c; state= 2; break;
    case 2:
      if (data_p<VUC_IN_DATA_SIZE)
        data[data_p++]= c;
      if (--data_cnt)
        break;
      if (cmd==VUC_CMD_META) {
        data[data_p]= 0;
#if (VUC_DBG_PROTO)
        if (adr==VUC_META_HELLO) {
          vuc_dbg_beg(12+1+1+1); vuc_dbgs("META HELLO: "); vuc_dbgn4(c>>4); vuc_dbgs("."); vuc_dbgn4(c); vuc_dbg_end();
        } else {
          vuc_dbg_beg(5+2+3+data_p+1); vuc_dbgs("META "); vuc_dbgn8(adr); vuc_dbgs(": '"); vuc_dbgs(data); vuc_dbgs("'"); vuc_dbg_end();
        }
#endif
        vuc_meta(adr, data_len, data);
        data_p= state= 0; break;
      }
//      if (cmd==VUC_CMD_PUT) { // can only be VUC_CMD_PUT
#if (VUC_DBG_PROTO)
        vuc_dbg_beg(4+2+2+2+6); vuc_dbgs("PUT "); vuc_dbgn8(adr); vuc_dbgs(": "); vuc_dbgn8(data_p); vuc_dbgs(" bytes"); vuc_dbg_end();
#endif
        vuc_put_meta[adr].func(data);
//        data_p= state= 0; break;
//      }
      data_p= state= 0; break;
  }
}
